// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:152

#ifndef _TAO_IDL_MONITORC_EZ8FO7_H_
#define _TAO_IDL_MONITORC_EZ8FO7_H_

#include /**/ "ace/pre.h"


#include /**/ "ace/config-all.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


#include /**/ "monitor_export.h"
#include "tao/ORB.h"
#include "tao/SystemException.h"
#include "tao/Basic_Types.h"
#include "tao/ORB_Constants.h"
#include "dds/DCPS/ZeroCopyInfoSeq_T.h"
#include "tao/Object.h"
#include "tao/String_Manager_T.h"
#include "tao/Sequence_T.h"
#include "tao/Objref_VarOut_T.h"
#include "tao/Seq_Var_T.h"
#include "tao/Seq_Out_T.h"
#include "tao/VarOut_T.h"
#include "tao/Arg_Traits_T.h"
#include "tao/Basic_Arguments.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/Any_Insert_Policy_T.h"
#include "tao/Basic_Argument_T.h"
#include "tao/Fixed_Size_Argument_T.h"
#include "tao/Var_Size_Argument_T.h"
#include "tao/Object_Argument_T.h"
#include "tao/UB_String_Arguments.h"
#include /**/ "tao/Version.h"
#include /**/ "tao/Versioned_Namespace.h"
#include /**/ "dds/Versioned_Namespace.h"

#include "dds/DdsDcpsInfrastructureC.h"
#include "dds/DdsDcpsGuidC.h"
#include "tao/ULongSeqC.h"

#if TAO_MAJOR_VERSION != 2 || TAO_MINOR_VERSION != 2 || TAO_BETA_VERSION != 0
#error This file should be regenerated with TAO_IDL
#endif

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO OpenDDS_monitor_Export

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_root/root_ch.cpp:160

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL



namespace TAO
{
  template<typename T> class Narrow_Utils;
}
TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace DCPS
  {

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Long MONITOR_DOMAIN_ID = -999;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Long MONITOR_TRANSPORT_ID = 999;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const SERVICE_PARTICIPANT_MONITOR_TOPIC = "Service Participant Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const DOMAIN_PARTICIPANT_MONITOR_TOPIC = "Domain Participant Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const TOPIC_MONITOR_TOPIC = "Topic Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const PUBLISHER_MONITOR_TOPIC = "Publisher Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const SUBSCRIBER_MONITOR_TOPIC = "Subscriber Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const DATA_WRITER_MONITOR_TOPIC = "Data Writer Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const DATA_WRITER_PERIODIC_MONITOR_TOPIC = "Data Writer Periodic Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const DATA_READER_MONITOR_TOPIC = "Data Reader Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const DATA_READER_PERIODIC_MONITOR_TOPIC = "Data Reader Periodic Monitor";

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const char *const TRANSPORT_MONITOR_TOPIC = "Transport Monitor";

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct Statistics;

    typedef
      ::TAO_Fixed_Var_T<
          Statistics
        >
      Statistics_var;

    typedef
      Statistics &
      Statistics_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export Statistics
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef Statistics_var _var_type;
      typedef Statistics_out _out_type;
      
      ::CORBA::ULong n;
      ::CORBA::Double maximum;
      ::CORBA::Double minimum;
      ::CORBA::Double mean;
      ::CORBA::Double variance;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_enum/enum_ch.cpp:47

    enum ValueEnumType
    {
      INTEGER_TYPE,
      DOUBLE_TYPE,
      STRING_TYPE,
      STATISTICS_TYPE,
      STRING_LIST_TYPE
    };

    typedef ValueEnumType &ValueEnumType_out;

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    class ValueUnion;

    typedef
      ::TAO_Var_Var_T<
          ValueUnion
        >
      ValueUnion_var;

    typedef
      ::TAO_Out_T<
          ValueUnion
        >
      ValueUnion_out;

    class OpenDDS_monitor_Export ValueUnion
    {
    public:
      ValueUnion (void);
      ValueUnion (const ValueUnion &);
      ~ValueUnion (void);

      ValueUnion &operator= (const ValueUnion &);

      // TAO_IDL - Generated from
      // be/be_visitor_union/discriminant_ch.cpp:70

      void _d (OpenDDS::DCPS::ValueEnumType);
      OpenDDS::DCPS::ValueEnumType _d (void) const;

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef ValueUnion_var _var_type;
      typedef ValueUnion_out _out_type;

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:452

      void integer_value ( ::CORBA::Long);
      ::CORBA::Long integer_value (void) const;

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:452

      void double_value ( ::CORBA::Double);
      ::CORBA::Double double_value (void) const;

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:583

      void string_value (char *);
      void string_value (const char *);
      void string_value (const ::CORBA::String_var&);
      const char *string_value (void) const;

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void stat_value (const OpenDDS::DCPS::Statistics &);
      const OpenDDS::DCPS::Statistics &stat_value (void) const;
      OpenDDS::DCPS::Statistics &stat_value (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:551

      void string_seq_value (const DDS::StringSeq &);
      const DDS::StringSeq &string_seq_value (void) const;
      DDS::StringSeq &string_seq_value (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union/union_ch.cpp:124

      void _default (void);
    private:
      OpenDDS::DCPS::ValueEnumType disc_;

      union
      {
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:380
        ::CORBA::Long integer_value_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:380
        ::CORBA::Double double_value_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:477
        char *string_value_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::Statistics stat_value_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:447
        DDS::StringSeq *string_seq_value_;
      } u_;

      /// TAO extension - frees any allocated storage.
      void _reset (void);
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct NameValuePair;

    typedef
      ::TAO_Var_Var_T<
          NameValuePair
        >
      NameValuePair_var;

    typedef
      ::TAO_Out_T<
          NameValuePair
        >
      NameValuePair_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export NameValuePair
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef NameValuePair_var _var_type;
      typedef NameValuePair_out _out_type;
      
      ::TAO::String_Manager name;
      

      OpenDDS::DCPS::ValueUnion value;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_OPENDDS_DCPS_NVPSEQ_CH_)
#define _OPENDDS_DCPS_NVPSEQ_CH_

    class NVPSeq;

    typedef
      ::TAO_VarSeq_Var_T<
          NVPSeq
        >
      NVPSeq_var;

    typedef
      ::TAO_Seq_Out_T<
          NVPSeq
        >
      NVPSeq_out;

    class OpenDDS_monitor_Export NVPSeq
      : public
          ::TAO::unbounded_value_sequence<
              NameValuePair
            >
    {
    public:
      NVPSeq (void);
      NVPSeq ( ::CORBA::ULong max);
      NVPSeq (
        ::CORBA::ULong max,
        ::CORBA::ULong length,
        NameValuePair* buffer,
        ::CORBA::Boolean release = false);
      NVPSeq (const NVPSeq &);
      virtual ~NVPSeq (void);
      

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef NVPSeq_var _var_type;
      typedef NVPSeq_out _out_type;
    };

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct ServiceParticipantReport;

    typedef
      ::TAO_Var_Var_T<
          ServiceParticipantReport
        >
      ServiceParticipantReport_var;

    typedef
      ::TAO_Out_T<
          ServiceParticipantReport
        >
      ServiceParticipantReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export ServiceParticipantReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef ServiceParticipantReport_var _var_type;
      typedef ServiceParticipantReport_out _out_type;
      
      ::TAO::String_Manager host;
      ::CORBA::Long pid;
      OpenDDS::DCPS::GUIDSeq domain_participants;
      CORBA::ULongSeq transports;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DomainParticipantReport;

    typedef
      ::TAO_Var_Var_T<
          DomainParticipantReport
        >
      DomainParticipantReport_var;

    typedef
      ::TAO_Out_T<
          DomainParticipantReport
        >
      DomainParticipantReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DomainParticipantReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DomainParticipantReport_var _var_type;
      typedef DomainParticipantReport_out _out_type;
      
      ::TAO::String_Manager host;
      ::CORBA::Long pid;
      OpenDDS::DCPS::GUID_t dp_id;
      DDS::DomainId_t domain_id;
      OpenDDS::DCPS::GUIDSeq topics;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct TopicReport;

    typedef
      ::TAO_Var_Var_T<
          TopicReport
        >
      TopicReport_var;

    typedef
      ::TAO_Out_T<
          TopicReport
        >
      TopicReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export TopicReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef TopicReport_var _var_type;
      typedef TopicReport_out _out_type;
      
      OpenDDS::DCPS::GUID_t dp_id;
      OpenDDS::DCPS::GUID_t topic_id;
      ::TAO::String_Manager topic_name;
      ::TAO::String_Manager type_name;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct PublisherReport;

    typedef
      ::TAO_Var_Var_T<
          PublisherReport
        >
      PublisherReport_var;

    typedef
      ::TAO_Out_T<
          PublisherReport
        >
      PublisherReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export PublisherReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef PublisherReport_var _var_type;
      typedef PublisherReport_out _out_type;
      
      DDS::InstanceHandle_t handle;
      OpenDDS::DCPS::GUID_t dp_id;
      ::CORBA::ULong transport_id;
      OpenDDS::DCPS::GUIDSeq writers;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct SubscriberReport;

    typedef
      ::TAO_Var_Var_T<
          SubscriberReport
        >
      SubscriberReport_var;

    typedef
      ::TAO_Out_T<
          SubscriberReport
        >
      SubscriberReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export SubscriberReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef SubscriberReport_var _var_type;
      typedef SubscriberReport_out _out_type;
      
      DDS::InstanceHandle_t handle;
      OpenDDS::DCPS::GUID_t dp_id;
      ::CORBA::ULong transport_id;
      OpenDDS::DCPS::GUIDSeq readers;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataWriterAssociation;

    typedef
      ::TAO_Fixed_Var_T<
          DataWriterAssociation
        >
      DataWriterAssociation_var;

    typedef
      DataWriterAssociation &
      DataWriterAssociation_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataWriterAssociation
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataWriterAssociation_var _var_type;
      typedef DataWriterAssociation_out _out_type;
      
      OpenDDS::DCPS::GUID_t dr_id;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_OPENDDS_DCPS_DWASSOCIATIONS_CH_)
#define _OPENDDS_DCPS_DWASSOCIATIONS_CH_

    class DWAssociations;

    typedef
      ::TAO_FixedSeq_Var_T<
          DWAssociations
        >
      DWAssociations_var;

    typedef
      ::TAO_Seq_Out_T<
          DWAssociations
        >
      DWAssociations_out;

    class OpenDDS_monitor_Export DWAssociations
      : public
          ::TAO::unbounded_value_sequence<
              DataWriterAssociation
            >
    {
    public:
      DWAssociations (void);
      DWAssociations ( ::CORBA::ULong max);
      DWAssociations (
        ::CORBA::ULong max,
        ::CORBA::ULong length,
        DataWriterAssociation* buffer,
        ::CORBA::Boolean release = false);
      DWAssociations (const DWAssociations &);
      virtual ~DWAssociations (void);
      

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DWAssociations_var _var_type;
      typedef DWAssociations_out _out_type;
    };

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataWriterReport;

    typedef
      ::TAO_Var_Var_T<
          DataWriterReport
        >
      DataWriterReport_var;

    typedef
      ::TAO_Out_T<
          DataWriterReport
        >
      DataWriterReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataWriterReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataWriterReport_var _var_type;
      typedef DataWriterReport_out _out_type;
      
      OpenDDS::DCPS::GUID_t dp_id;
      DDS::InstanceHandle_t pub_handle;
      OpenDDS::DCPS::GUID_t dw_id;
      OpenDDS::DCPS::GUID_t topic_id;
      DDS::InstanceHandleSeq instances;
      OpenDDS::DCPS::DWAssociations associations;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataWriterAssociationPeriodic;

    typedef
      ::TAO_Fixed_Var_T<
          DataWriterAssociationPeriodic
        >
      DataWriterAssociationPeriodic_var;

    typedef
      DataWriterAssociationPeriodic &
      DataWriterAssociationPeriodic_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataWriterAssociationPeriodic
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataWriterAssociationPeriodic_var _var_type;
      typedef DataWriterAssociationPeriodic_out _out_type;
      
      OpenDDS::DCPS::GUID_t dr_id;
      ::CORBA::ULong sequence_number;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_OPENDDS_DCPS_DWASSOCIATIONSPERIODIC_CH_)
#define _OPENDDS_DCPS_DWASSOCIATIONSPERIODIC_CH_

    class DWAssociationsPeriodic;

    typedef
      ::TAO_FixedSeq_Var_T<
          DWAssociationsPeriodic
        >
      DWAssociationsPeriodic_var;

    typedef
      ::TAO_Seq_Out_T<
          DWAssociationsPeriodic
        >
      DWAssociationsPeriodic_out;

    class OpenDDS_monitor_Export DWAssociationsPeriodic
      : public
          ::TAO::unbounded_value_sequence<
              DataWriterAssociationPeriodic
            >
    {
    public:
      DWAssociationsPeriodic (void);
      DWAssociationsPeriodic ( ::CORBA::ULong max);
      DWAssociationsPeriodic (
        ::CORBA::ULong max,
        ::CORBA::ULong length,
        DataWriterAssociationPeriodic* buffer,
        ::CORBA::Boolean release = false);
      DWAssociationsPeriodic (const DWAssociationsPeriodic &);
      virtual ~DWAssociationsPeriodic (void);
      

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DWAssociationsPeriodic_var _var_type;
      typedef DWAssociationsPeriodic_out _out_type;
    };

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataWriterPeriodicReport;

    typedef
      ::TAO_Var_Var_T<
          DataWriterPeriodicReport
        >
      DataWriterPeriodicReport_var;

    typedef
      ::TAO_Out_T<
          DataWriterPeriodicReport
        >
      DataWriterPeriodicReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataWriterPeriodicReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataWriterPeriodicReport_var _var_type;
      typedef DataWriterPeriodicReport_out _out_type;
      
      OpenDDS::DCPS::GUID_t dw_id;
      ::CORBA::ULong data_dropped_count;
      ::CORBA::ULong data_delivered_count;
      ::CORBA::ULong control_dropped_count;
      ::CORBA::ULong control_delivered_count;
      OpenDDS::DCPS::DWAssociationsPeriodic associations;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataReaderAssociation;

    typedef
      ::TAO_Fixed_Var_T<
          DataReaderAssociation
        >
      DataReaderAssociation_var;

    typedef
      DataReaderAssociation &
      DataReaderAssociation_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataReaderAssociation
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataReaderAssociation_var _var_type;
      typedef DataReaderAssociation_out _out_type;
      
      OpenDDS::DCPS::GUID_t dw_id;
      ::CORBA::Short state;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_OPENDDS_DCPS_DRASSOCIATIONS_CH_)
#define _OPENDDS_DCPS_DRASSOCIATIONS_CH_

    class DRAssociations;

    typedef
      ::TAO_FixedSeq_Var_T<
          DRAssociations
        >
      DRAssociations_var;

    typedef
      ::TAO_Seq_Out_T<
          DRAssociations
        >
      DRAssociations_out;

    class OpenDDS_monitor_Export DRAssociations
      : public
          ::TAO::unbounded_value_sequence<
              DataReaderAssociation
            >
    {
    public:
      DRAssociations (void);
      DRAssociations ( ::CORBA::ULong max);
      DRAssociations (
        ::CORBA::ULong max,
        ::CORBA::ULong length,
        DataReaderAssociation* buffer,
        ::CORBA::Boolean release = false);
      DRAssociations (const DRAssociations &);
      virtual ~DRAssociations (void);
      

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DRAssociations_var _var_type;
      typedef DRAssociations_out _out_type;
    };

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataReaderReport;

    typedef
      ::TAO_Var_Var_T<
          DataReaderReport
        >
      DataReaderReport_var;

    typedef
      ::TAO_Out_T<
          DataReaderReport
        >
      DataReaderReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataReaderReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataReaderReport_var _var_type;
      typedef DataReaderReport_out _out_type;
      
      OpenDDS::DCPS::GUID_t dp_id;
      DDS::InstanceHandle_t sub_handle;
      OpenDDS::DCPS::GUID_t dr_id;
      OpenDDS::DCPS::GUID_t topic_id;
      DDS::InstanceHandleSeq instances;
      OpenDDS::DCPS::DRAssociations associations;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataReaderAssociationPeriodic;

    typedef
      ::TAO_Fixed_Var_T<
          DataReaderAssociationPeriodic
        >
      DataReaderAssociationPeriodic_var;

    typedef
      DataReaderAssociationPeriodic &
      DataReaderAssociationPeriodic_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataReaderAssociationPeriodic
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataReaderAssociationPeriodic_var _var_type;
      typedef DataReaderAssociationPeriodic_out _out_type;
      
      OpenDDS::DCPS::GUID_t dw_id;
      ::CORBA::ULong samples_available;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_OPENDDS_DCPS_DRASSOCIATIONSPERIODIC_CH_)
#define _OPENDDS_DCPS_DRASSOCIATIONSPERIODIC_CH_

    class DRAssociationsPeriodic;

    typedef
      ::TAO_FixedSeq_Var_T<
          DRAssociationsPeriodic
        >
      DRAssociationsPeriodic_var;

    typedef
      ::TAO_Seq_Out_T<
          DRAssociationsPeriodic
        >
      DRAssociationsPeriodic_out;

    class OpenDDS_monitor_Export DRAssociationsPeriodic
      : public
          ::TAO::unbounded_value_sequence<
              DataReaderAssociationPeriodic
            >
    {
    public:
      DRAssociationsPeriodic (void);
      DRAssociationsPeriodic ( ::CORBA::ULong max);
      DRAssociationsPeriodic (
        ::CORBA::ULong max,
        ::CORBA::ULong length,
        DataReaderAssociationPeriodic* buffer,
        ::CORBA::Boolean release = false);
      DRAssociationsPeriodic (const DRAssociationsPeriodic &);
      virtual ~DRAssociationsPeriodic (void);
      

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DRAssociationsPeriodic_var _var_type;
      typedef DRAssociationsPeriodic_out _out_type;
    };

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct DataReaderPeriodicReport;

    typedef
      ::TAO_Var_Var_T<
          DataReaderPeriodicReport
        >
      DataReaderPeriodicReport_var;

    typedef
      ::TAO_Out_T<
          DataReaderPeriodicReport
        >
      DataReaderPeriodicReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export DataReaderPeriodicReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef DataReaderPeriodicReport_var _var_type;
      typedef DataReaderPeriodicReport_out _out_type;
      
      OpenDDS::DCPS::GUID_t dr_id;
      OpenDDS::DCPS::DRAssociationsPeriodic associations;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct TransportReport;

    typedef
      ::TAO_Var_Var_T<
          TransportReport
        >
      TransportReport_var;

    typedef
      ::TAO_Out_T<
          TransportReport
        >
      TransportReport_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_monitor_Export TransportReport
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef TransportReport_var _var_type;
      typedef TransportReport_out _out_type;
      
      ::TAO::String_Manager host;
      ::CORBA::Long pid;
      ::CORBA::ULong transport_id;
      ::TAO::String_Manager transport_type;
      OpenDDS::DCPS::NVPSeq values;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_enum/enum_ch.cpp:47

    enum ReportType
    {
      SERVICE_PARTICIPANT_REPORT_TYPE,
      DOMAIN_PARTICIPANT_REPORT_TYPE,
      TOPIC_REPORT_TYPE,
      PUBLISHER_REPORT_TYPE,
      SUBSCRIBER_REPORT_TYPE,
      DATA_WRITER_REPORT_TYPE,
      DATA_WRITER_PERIODIC_REPORT_TYPE,
      DATA_READER_REPORT_TYPE,
      DATA_READER_PERIODIC_REPORT_TYPE,
      TRANSPORT_REPORT_TYPE
    };

    typedef ReportType &ReportType_out;

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    class GenericReport;

    typedef
      ::TAO_Var_Var_T<
          GenericReport
        >
      GenericReport_var;

    typedef
      ::TAO_Out_T<
          GenericReport
        >
      GenericReport_out;

    class OpenDDS_monitor_Export GenericReport
    {
    public:
      GenericReport (void);
      GenericReport (const GenericReport &);
      ~GenericReport (void);

      GenericReport &operator= (const GenericReport &);

      // TAO_IDL - Generated from
      // be/be_visitor_union/discriminant_ch.cpp:70

      void _d (OpenDDS::DCPS::ReportType);
      OpenDDS::DCPS::ReportType _d (void) const;

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef GenericReport_var _var_type;
      typedef GenericReport_out _out_type;

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void sp_report (const OpenDDS::DCPS::ServiceParticipantReport &);
      const OpenDDS::DCPS::ServiceParticipantReport &sp_report (void) const;
      OpenDDS::DCPS::ServiceParticipantReport &sp_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void dp_report (const OpenDDS::DCPS::DomainParticipantReport &);
      const OpenDDS::DCPS::DomainParticipantReport &dp_report (void) const;
      OpenDDS::DCPS::DomainParticipantReport &dp_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void topic_report (const OpenDDS::DCPS::TopicReport &);
      const OpenDDS::DCPS::TopicReport &topic_report (void) const;
      OpenDDS::DCPS::TopicReport &topic_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void publisher_report (const OpenDDS::DCPS::PublisherReport &);
      const OpenDDS::DCPS::PublisherReport &publisher_report (void) const;
      OpenDDS::DCPS::PublisherReport &publisher_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void subscriber_report (const OpenDDS::DCPS::SubscriberReport &);
      const OpenDDS::DCPS::SubscriberReport &subscriber_report (void) const;
      OpenDDS::DCPS::SubscriberReport &subscriber_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void dw_report (const OpenDDS::DCPS::DataWriterReport &);
      const OpenDDS::DCPS::DataWriterReport &dw_report (void) const;
      OpenDDS::DCPS::DataWriterReport &dw_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void dw_per_report (const OpenDDS::DCPS::DataWriterPeriodicReport &);
      const OpenDDS::DCPS::DataWriterPeriodicReport &dw_per_report (void) const;
      OpenDDS::DCPS::DataWriterPeriodicReport &dw_per_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void dr_report (const OpenDDS::DCPS::DataReaderReport &);
      const OpenDDS::DCPS::DataReaderReport &dr_report (void) const;
      OpenDDS::DCPS::DataReaderReport &dr_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void dr_per_report (const OpenDDS::DCPS::DataReaderPeriodicReport &);
      const OpenDDS::DCPS::DataReaderPeriodicReport &dr_per_report (void) const;
      OpenDDS::DCPS::DataReaderPeriodicReport &dr_per_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union_branch/public_ch.cpp:659

      void transport_report (const OpenDDS::DCPS::TransportReport &);
      const OpenDDS::DCPS::TransportReport &transport_report (void) const;
      OpenDDS::DCPS::TransportReport &transport_report (void);

      // TAO_IDL - Generated from
      // be/be_visitor_union/union_ch.cpp:124

      void _default (void);
    private:
      OpenDDS::DCPS::ReportType disc_;

      union
      {
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::ServiceParticipantReport *sp_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::DomainParticipantReport *dp_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::TopicReport *topic_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::PublisherReport *publisher_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::SubscriberReport *subscriber_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::DataWriterReport *dw_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::DataWriterPeriodicReport *dw_per_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::DataReaderReport *dr_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::DataReaderPeriodicReport *dr_per_report_;
        // TAO_IDL - Generated from
        // be/be_visitor_union_branch/private_ch.cpp:522
        OpenDDS::DCPS::TransportReport *transport_report_;
      } u_;

      /// TAO extension - frees any allocated storage.
      void _reset (void);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_DCPS_PROCESSMONITOR__VAR_OUT_CH_)
#define _OPENDDS_DCPS_PROCESSMONITOR__VAR_OUT_CH_

    class ProcessMonitor;
    typedef ProcessMonitor *ProcessMonitor_ptr;

    typedef
      TAO_Objref_Var_T<
          ProcessMonitor
        >
      ProcessMonitor_var;
    
    typedef
      TAO_Objref_Out_T<
          ProcessMonitor
        >
      ProcessMonitor_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_monitor_Export ProcessMonitor
      : public virtual ::CORBA::Object
    {
    public:
      friend class TAO::Narrow_Utils<ProcessMonitor>;

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef ProcessMonitor_ptr _ptr_type;
      typedef ProcessMonitor_var _var_type;
      typedef ProcessMonitor_out _out_type;

      // The static operations.
      static ProcessMonitor_ptr _duplicate (ProcessMonitor_ptr obj);

      static void _tao_release (ProcessMonitor_ptr obj);

      static ProcessMonitor_ptr _narrow (::CORBA::Object_ptr obj);
      static ProcessMonitor_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static ProcessMonitor_ptr _nil (void);

      virtual ::OpenDDS::DCPS::GenericReport * retrieve_report (
        const char * name);

      virtual void enable_report_collection (
        void);

      virtual void disable_report_collection (
        void);

      virtual void enable_report_publishing (
        void);

      virtual void diable_report_publishing (
        void);

      virtual void set_publishing_period (
        const ::DDS::Duration_t & period);

      virtual ::DDS::Duration_t get_publishing_period (
        void);

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Concrete interface only.
      ProcessMonitor (void);

      // Concrete non-local interface only.
      ProcessMonitor (
          ::IOP::IOR *ior,
          TAO_ORB_Core *orb_core);
      
      // Non-local interface only.
      ProcessMonitor (
          TAO_Stub *objref,
          ::CORBA::Boolean _tao_collocated = false,
          TAO_Abstract_ServantBase *servant = 0,
          TAO_ORB_Core *orb_core = 0);

      virtual ~ProcessMonitor (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      ProcessMonitor (const ProcessMonitor &);

      void operator= (const ProcessMonitor &);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::DCPS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::Statistics>
    : public
        Fixed_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::Statistics,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::ValueEnumType>
    : public
        Basic_Arg_Traits_T<
            ::OpenDDS::DCPS::ValueEnumType,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:1058

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::ValueUnion>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::ValueUnion,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::NameValuePair>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::NameValuePair,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::NVPSeq>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::NVPSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::ServiceParticipantReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::ServiceParticipantReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DomainParticipantReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DomainParticipantReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::TopicReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::TopicReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::PublisherReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::PublisherReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::SubscriberReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::SubscriberReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataWriterAssociation>
    : public
        Fixed_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataWriterAssociation,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DWAssociations>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DWAssociations,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataWriterReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataWriterReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataWriterAssociationPeriodic>
    : public
        Fixed_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataWriterAssociationPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DWAssociationsPeriodic>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DWAssociationsPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataWriterPeriodicReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataWriterPeriodicReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataReaderAssociation>
    : public
        Fixed_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataReaderAssociation,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DRAssociations>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DRAssociations,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataReaderReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataReaderReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataReaderAssociationPeriodic>
    : public
        Fixed_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataReaderAssociationPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DRAssociationsPeriodic>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DRAssociationsPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::DataReaderPeriodicReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::DataReaderPeriodicReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::TransportReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::TransportReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::ReportType>
    : public
        Basic_Arg_Traits_T<
            ::OpenDDS::DCPS::ReportType,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:1058

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::GenericReport>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::GenericReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:147

#if !defined (_OPENDDS_DCPS_PROCESSMONITOR__ARG_TRAITS_)
#define _OPENDDS_DCPS_PROCESSMONITOR__ARG_TRAITS_

  template<>
  class  Arg_Traits< ::OpenDDS::DCPS::ProcessMonitor>
    : public
        Object_Arg_Traits_T<
            ::OpenDDS::DCPS::ProcessMonitor_ptr,
            ::OpenDDS::DCPS::ProcessMonitor_var,
            ::OpenDDS::DCPS::ProcessMonitor_out,
            TAO::Objref_Traits<OpenDDS::DCPS::ProcessMonitor>,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

#endif /* end #if !defined */
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_traits.cpp:62


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Traits specializations.
namespace TAO
{

#if !defined (_OPENDDS_DCPS_PROCESSMONITOR__TRAITS_)
#define _OPENDDS_DCPS_PROCESSMONITOR__TRAITS_

  template<>
  struct OpenDDS_monitor_Export Objref_Traits< ::OpenDDS::DCPS::ProcessMonitor>
  {
    static ::OpenDDS::DCPS::ProcessMonitor_ptr duplicate (
        ::OpenDDS::DCPS::ProcessMonitor_ptr p);
    static void release (
        ::OpenDDS::DCPS::ProcessMonitor_ptr p);
    static ::OpenDDS::DCPS::ProcessMonitor_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::DCPS::ProcessMonitor_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */
}
TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::Statistics &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::Statistics &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, OpenDDS::DCPS::ValueEnumType _tao_enumerator);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, OpenDDS::DCPS::ValueEnumType &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_union/cdr_op_ch.cpp:41



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::ValueUnion &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::ValueUnion &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::NameValuePair &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::NameValuePair &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_OpenDDS_DCPS_NVPSeq_H_
#define _TAO_CDR_OP_OpenDDS_DCPS_NVPSeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_monitor_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const OpenDDS::DCPS::NVPSeq &_tao_sequence);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    OpenDDS::DCPS::NVPSeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_OpenDDS_DCPS_NVPSeq_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::ServiceParticipantReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::ServiceParticipantReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DomainParticipantReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DomainParticipantReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::TopicReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::TopicReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::PublisherReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::PublisherReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::SubscriberReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::SubscriberReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataWriterAssociation &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataWriterAssociation &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_OpenDDS_DCPS_DWAssociations_H_
#define _TAO_CDR_OP_OpenDDS_DCPS_DWAssociations_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_monitor_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const OpenDDS::DCPS::DWAssociations &_tao_sequence);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    OpenDDS::DCPS::DWAssociations &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_OpenDDS_DCPS_DWAssociations_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataWriterReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataWriterReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataWriterAssociationPeriodic &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataWriterAssociationPeriodic &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_OpenDDS_DCPS_DWAssociationsPeriodic_H_
#define _TAO_CDR_OP_OpenDDS_DCPS_DWAssociationsPeriodic_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_monitor_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const OpenDDS::DCPS::DWAssociationsPeriodic &_tao_sequence);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    OpenDDS::DCPS::DWAssociationsPeriodic &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_OpenDDS_DCPS_DWAssociationsPeriodic_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataWriterPeriodicReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataWriterPeriodicReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataReaderAssociation &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataReaderAssociation &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_OpenDDS_DCPS_DRAssociations_H_
#define _TAO_CDR_OP_OpenDDS_DCPS_DRAssociations_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_monitor_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const OpenDDS::DCPS::DRAssociations &_tao_sequence);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    OpenDDS::DCPS::DRAssociations &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_OpenDDS_DCPS_DRAssociations_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataReaderReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataReaderReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataReaderAssociationPeriodic &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataReaderAssociationPeriodic &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_OpenDDS_DCPS_DRAssociationsPeriodic_H_
#define _TAO_CDR_OP_OpenDDS_DCPS_DRAssociationsPeriodic_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_monitor_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const OpenDDS::DCPS::DRAssociationsPeriodic &_tao_sequence);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    OpenDDS::DCPS::DRAssociationsPeriodic &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_OpenDDS_DCPS_DRAssociationsPeriodic_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::DataReaderPeriodicReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::DataReaderPeriodicReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::TransportReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::TransportReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, OpenDDS::DCPS::ReportType _tao_enumerator);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, OpenDDS::DCPS::ReportType &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_union/cdr_op_ch.cpp:41



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::GenericReport &);
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::GenericReport &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_interface/cdr_op_ch.cpp:44


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_monitor_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::ProcessMonitor_ptr );
OpenDDS_monitor_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::ProcessMonitor_ptr &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_codegen.cpp:1703


OPENDDS_END_VERSIONED_NAMESPACE_DECL

#if defined (__ACE_INLINE__)
#include "monitorC.inl"
#endif /* defined INLINE */

#include /**/ "ace/post.h"

#endif /* ifndef */

